searchData={"items":[{"type":"module","title":"Calendar.ISO.Extension","doc":"A module to extend the calendar implementation that follows to ISO8601 with methods found in\nElixir 1.5.1. This is to allow ESpec to support Elixir >= 1.3.4 more easily.","ref":"Calendar.ISO.Extension.html"},{"type":"type","title":"Calendar.ISO.Extension.day/0","doc":"","ref":"Calendar.ISO.Extension.html#t:day/0"},{"type":"function","title":"Calendar.ISO.Extension.days_in_month/2","doc":"Returns how many days there are in the given year-month.","ref":"Calendar.ISO.Extension.html#days_in_month/2"},{"type":"function","title":"Examples - Calendar.ISO.Extension.days_in_month/2","doc":"iex> Calendar.ISO.days_in_month(1900, 1)\n    31\n    iex> Calendar.ISO.days_in_month(1900, 2)\n    28\n    iex> Calendar.ISO.days_in_month(2000, 2)\n    29\n    iex> Calendar.ISO.days_in_month(2001, 2)\n    28\n    iex> Calendar.ISO.days_in_month(2004, 2)\n    29\n    iex> Calendar.ISO.days_in_month(2004, 4)\n    30","ref":"Calendar.ISO.Extension.html#days_in_month/2-examples"},{"type":"function","title":"Calendar.ISO.Extension.leap_year?/1","doc":"","ref":"Calendar.ISO.Extension.html#leap_year?/1"},{"type":"type","title":"Calendar.ISO.Extension.month/0","doc":"","ref":"Calendar.ISO.Extension.html#t:month/0"},{"type":"function","title":"Calendar.ISO.Extension.naive_datetime_to_iso_days/7","doc":"Returns the `t:Calendar.iso_days` format of the specified date.","ref":"Calendar.ISO.Extension.html#naive_datetime_to_iso_days/7"},{"type":"function","title":"Examples - Calendar.ISO.Extension.naive_datetime_to_iso_days/7","doc":"iex> Calendar.ISO.naive_datetime_to_iso_days(0, 1, 1, 0, 0, 0, {0, 6})\n    {0, {0, 86400000000}}\n    iex> Calendar.ISO.naive_datetime_to_iso_days(2000, 1, 1, 12, 0, 0, {0, 6})\n    {730485, {43200000000, 86400000000}}\n    iex> Calendar.ISO.naive_datetime_to_iso_days(2000, 1, 1, 13, 0, 0, {0, 6})\n    {730485, {46800000000, 86400000000}}","ref":"Calendar.ISO.Extension.html#naive_datetime_to_iso_days/7-examples"},{"type":"function","title":"Calendar.ISO.Extension.time_to_day_fraction/4","doc":"Returns the normalized day fraction of the specified time.","ref":"Calendar.ISO.Extension.html#time_to_day_fraction/4"},{"type":"function","title":"Examples - Calendar.ISO.Extension.time_to_day_fraction/4","doc":"iex> Calendar.ISO.time_to_day_fraction(0, 0, 0, {0, 6})\n    {0, 86400000000}\n    iex> Calendar.ISO.time_to_day_fraction(12, 34, 56, {123, 6})\n    {45296000123, 86400000000}","ref":"Calendar.ISO.Extension.html#time_to_day_fraction/4-examples"},{"type":"type","title":"Calendar.ISO.Extension.year/0","doc":"","ref":"Calendar.ISO.Extension.html#t:year/0"},{"type":"module","title":"DateTime.Extension","doc":"A module to extend the calendar implementation that follows to ISO8601 with methods found in\nElixir 1.5.1. This is to allow ESpec to support Elixir >= 1.3.4 more easily.","ref":"DateTime.Extension.html"},{"type":"function","title":"DateTime.Extension.from_naive/2","doc":"Converts the given `NaiveDateTime` to `DateTime`.\n\nIt expects a time zone to put the NaiveDateTime in.\nCurrently it only supports \"Etc/UTC\" as time zone.","ref":"DateTime.Extension.html#from_naive/2"},{"type":"function","title":"Examples - DateTime.Extension.from_naive/2","doc":"iex> {:ok, datetime} = DateTime.from_naive(~N[2016-05-24 13:26:08.003], \"Etc/UTC\")\n    iex> datetime\n    #DateTime<2016-05-24 13:26:08.003Z>","ref":"DateTime.Extension.html#from_naive/2-examples"},{"type":"function","title":"DateTime.Extension.from_naive!/2","doc":"Converts the given `NaiveDateTime` to `DateTime`.\n\nIt expects a time zone to put the NaiveDateTime in.\nCurrently it only supports \"Etc/UTC\" as time zone.","ref":"DateTime.Extension.html#from_naive!/2"},{"type":"function","title":"Examples - DateTime.Extension.from_naive!/2","doc":"iex> DateTime.from_naive!(~N[2016-05-24 13:26:08.003], \"Etc/UTC\")\n    #DateTime<2016-05-24 13:26:08.003Z>","ref":"DateTime.Extension.html#from_naive!/2-examples"},{"type":"type","title":"DateTime.Extension.t/0","doc":"","ref":"DateTime.Extension.html#t:t/0"},{"type":"module","title":"ESpec","doc":"The ESpec basic module. Imports a lot of ESpec components.\nOne should `use` the module in spec modules.","ref":"ESpec.html"},{"type":"function","title":"ESpec.add_spec/1","doc":"Adds example to the agent.","ref":"ESpec.html#add_spec/1"},{"type":"function","title":"ESpec.configure/1","doc":"Allows to set the config options.\nESpec.configure(fn(config) ->\n  config.key value\n  config.another_key another_value\nend)","ref":"ESpec.html#configure/1"},{"type":"function","title":"ESpec.run/0","doc":"Runs the examples","ref":"ESpec.html#run/0"},{"type":"function","title":"ESpec.specs/0","doc":"Returns all examples.","ref":"ESpec.html#specs/0"},{"type":"function","title":"ESpec.start/0","doc":"Starts ESpec. Starts agents to store specs, mocks, cache 'let' values, etc.","ref":"ESpec.html#start/0"},{"type":"function","title":"ESpec.stop/0","doc":"Stops ESpec components","ref":"ESpec.html#stop/0"},{"type":"function","title":"ESpec.stop_specs_agent/0","doc":"","ref":"ESpec.html#stop_specs_agent/0"},{"type":"module","title":"ESpec.Allow","doc":"Defines helper functions for mocking and stubbing.\nThese functions wrap arguments for ESpec.AllowTo module.","ref":"ESpec.Allow.html"},{"type":"function","title":"ESpec.Allow.accept/1","doc":"","ref":"ESpec.Allow.html#accept/1"},{"type":"function","title":"ESpec.Allow.accept/2","doc":"Wraps arguments for `ESpec.AllowTo.to/2`.","ref":"ESpec.Allow.html#accept/2"},{"type":"function","title":"ESpec.Allow.accept/3","doc":"","ref":"ESpec.Allow.html#accept/3"},{"type":"function","title":"ESpec.Allow.allow/1","doc":"Wrapper for `ESpec.AllowTo`.","ref":"ESpec.Allow.html#allow/1"},{"type":"function","title":"ESpec.Allow.passthrough/1","doc":"Delegates to `:meck.passthrough/1`.","ref":"ESpec.Allow.html#passthrough/1"},{"type":"module","title":"ESpec.AllowTo","doc":"Defines `to/2` function which makes the mock.","ref":"ESpec.AllowTo.html"},{"type":"function","title":"ESpec.AllowTo.to/2","doc":"Makes specific mock with ESpec.Mock.expect/3.","ref":"ESpec.AllowTo.html#to/2"},{"type":"module","title":"ESpec.Assert","doc":"Defines `assert` and `refute` helper functions.","ref":"ESpec.Assert.html"},{"type":"function","title":"ESpec.Assert.assert/1","doc":"Calls be_truthy assertion","ref":"ESpec.Assert.html#assert/1"},{"type":"function","title":"ESpec.Assert.refute/1","doc":"Calls be_falsy assertion","ref":"ESpec.Assert.html#refute/1"},{"type":"module","title":"ESpec.AssertReceive","doc":"Defines `assert_receive` and `assert_received` helper macros","ref":"ESpec.AssertReceive.html"},{"type":"macro","title":"ESpec.AssertReceive.assert_receive/2","doc":"Asserts that a message matching `pattern` was or is going to be received.","ref":"ESpec.AssertReceive.html#assert_receive/2"},{"type":"macro","title":"ESpec.AssertReceive.assert_received/1","doc":"Asserts that a message matching `pattern` was received and is in the current process' mailbox.","ref":"ESpec.AssertReceive.html#assert_received/1"},{"type":"module","title":"ESpec.AssertionHelpers","doc":"Defines helper functions for modules which use ESpec.\nThese functions wrap arguments for ESpec.ExpectTo module.\nSee `ESpec.Assertion` module for corresponding 'assertion modules'","ref":"ESpec.AssertionHelpers.html"},{"type":"function","title":"ESpec.AssertionHelpers.accepted/3","doc":"","ref":"ESpec.AssertionHelpers.html#accepted/3"},{"type":"function","title":"ESpec.AssertionHelpers.be/1","doc":"","ref":"ESpec.AssertionHelpers.html#be/1"},{"type":"function","title":"ESpec.AssertionHelpers.be/2","doc":"","ref":"ESpec.AssertionHelpers.html#be/2"},{"type":"function","title":"ESpec.AssertionHelpers.be/3","doc":"","ref":"ESpec.AssertionHelpers.html#be/3"},{"type":"function","title":"ESpec.AssertionHelpers.be_alive/0","doc":"","ref":"ESpec.AssertionHelpers.html#be_alive/0"},{"type":"function","title":"ESpec.AssertionHelpers.be_atom/0","doc":"","ref":"ESpec.AssertionHelpers.html#be_atom/0"},{"type":"function","title":"ESpec.AssertionHelpers.be_between/2","doc":"","ref":"ESpec.AssertionHelpers.html#be_between/2"},{"type":"function","title":"ESpec.AssertionHelpers.be_binary/0","doc":"","ref":"ESpec.AssertionHelpers.html#be_binary/0"},{"type":"function","title":"ESpec.AssertionHelpers.be_bitstring/0","doc":"","ref":"ESpec.AssertionHelpers.html#be_bitstring/0"},{"type":"function","title":"ESpec.AssertionHelpers.be_blank/0","doc":"","ref":"ESpec.AssertionHelpers.html#be_blank/0"},{"type":"function","title":"ESpec.AssertionHelpers.be_boolean/0","doc":"","ref":"ESpec.AssertionHelpers.html#be_boolean/0"},{"type":"function","title":"ESpec.AssertionHelpers.be_close_to/2","doc":"","ref":"ESpec.AssertionHelpers.html#be_close_to/2"},{"type":"function","title":"ESpec.AssertionHelpers.be_empty/0","doc":"","ref":"ESpec.AssertionHelpers.html#be_empty/0"},{"type":"function","title":"ESpec.AssertionHelpers.be_error_result/0","doc":"","ref":"ESpec.AssertionHelpers.html#be_error_result/0"},{"type":"function","title":"ESpec.AssertionHelpers.be_false/0","doc":"","ref":"ESpec.AssertionHelpers.html#be_false/0"},{"type":"function","title":"ESpec.AssertionHelpers.be_falsy/0","doc":"","ref":"ESpec.AssertionHelpers.html#be_falsy/0"},{"type":"function","title":"ESpec.AssertionHelpers.be_float/0","doc":"","ref":"ESpec.AssertionHelpers.html#be_float/0"},{"type":"function","title":"ESpec.AssertionHelpers.be_function/0","doc":"","ref":"ESpec.AssertionHelpers.html#be_function/0"},{"type":"function","title":"ESpec.AssertionHelpers.be_function/1","doc":"","ref":"ESpec.AssertionHelpers.html#be_function/1"},{"type":"function","title":"ESpec.AssertionHelpers.be_integer/0","doc":"","ref":"ESpec.AssertionHelpers.html#be_integer/0"},{"type":"function","title":"ESpec.AssertionHelpers.be_list/0","doc":"","ref":"ESpec.AssertionHelpers.html#be_list/0"},{"type":"function","title":"ESpec.AssertionHelpers.be_map/0","doc":"","ref":"ESpec.AssertionHelpers.html#be_map/0"},{"type":"function","title":"ESpec.AssertionHelpers.be_nil/0","doc":"","ref":"ESpec.AssertionHelpers.html#be_nil/0"},{"type":"function","title":"ESpec.AssertionHelpers.be_number/0","doc":"","ref":"ESpec.AssertionHelpers.html#be_number/0"},{"type":"function","title":"ESpec.AssertionHelpers.be_ok_result/0","doc":"","ref":"ESpec.AssertionHelpers.html#be_ok_result/0"},{"type":"function","title":"ESpec.AssertionHelpers.be_pid/0","doc":"","ref":"ESpec.AssertionHelpers.html#be_pid/0"},{"type":"function","title":"ESpec.AssertionHelpers.be_port/0","doc":"","ref":"ESpec.AssertionHelpers.html#be_port/0"},{"type":"function","title":"ESpec.AssertionHelpers.be_printable/0","doc":"","ref":"ESpec.AssertionHelpers.html#be_printable/0"},{"type":"function","title":"ESpec.AssertionHelpers.be_reference/0","doc":"","ref":"ESpec.AssertionHelpers.html#be_reference/0"},{"type":"function","title":"ESpec.AssertionHelpers.be_struct/0","doc":"","ref":"ESpec.AssertionHelpers.html#be_struct/0"},{"type":"function","title":"ESpec.AssertionHelpers.be_struct/1","doc":"","ref":"ESpec.AssertionHelpers.html#be_struct/1"},{"type":"function","title":"ESpec.AssertionHelpers.be_true/0","doc":"","ref":"ESpec.AssertionHelpers.html#be_true/0"},{"type":"function","title":"ESpec.AssertionHelpers.be_truthy/0","doc":"","ref":"ESpec.AssertionHelpers.html#be_truthy/0"},{"type":"function","title":"ESpec.AssertionHelpers.be_tuple/0","doc":"","ref":"ESpec.AssertionHelpers.html#be_tuple/0"},{"type":"function","title":"ESpec.AssertionHelpers.be_valid_string/0","doc":"","ref":"ESpec.AssertionHelpers.html#be_valid_string/0"},{"type":"function","title":"ESpec.AssertionHelpers.change/1","doc":"","ref":"ESpec.AssertionHelpers.html#change/1"},{"type":"function","title":"ESpec.AssertionHelpers.change/2","doc":"","ref":"ESpec.AssertionHelpers.html#change/2"},{"type":"function","title":"ESpec.AssertionHelpers.change/3","doc":"","ref":"ESpec.AssertionHelpers.html#change/3"},{"type":"function","title":"ESpec.AssertionHelpers.contain_exactly/1","doc":"","ref":"ESpec.AssertionHelpers.html#contain_exactly/1"},{"type":"function","title":"ESpec.AssertionHelpers.end_with/1","doc":"","ref":"ESpec.AssertionHelpers.html#end_with/1"},{"type":"function","title":"ESpec.AssertionHelpers.eq/1","doc":"","ref":"ESpec.AssertionHelpers.html#eq/1"},{"type":"function","title":"ESpec.AssertionHelpers.eql/1","doc":"","ref":"ESpec.AssertionHelpers.html#eql/1"},{"type":"function","title":"ESpec.AssertionHelpers.have/1","doc":"","ref":"ESpec.AssertionHelpers.html#have/1"},{"type":"function","title":"ESpec.AssertionHelpers.have_all/1","doc":"","ref":"ESpec.AssertionHelpers.html#have_all/1"},{"type":"function","title":"ESpec.AssertionHelpers.have_any/1","doc":"","ref":"ESpec.AssertionHelpers.html#have_any/1"},{"type":"function","title":"ESpec.AssertionHelpers.have_at/2","doc":"","ref":"ESpec.AssertionHelpers.html#have_at/2"},{"type":"function","title":"ESpec.AssertionHelpers.have_byte_size/1","doc":"","ref":"ESpec.AssertionHelpers.html#have_byte_size/1"},{"type":"function","title":"ESpec.AssertionHelpers.have_count/1","doc":"","ref":"ESpec.AssertionHelpers.html#have_count/1"},{"type":"function","title":"ESpec.AssertionHelpers.have_count_by/2","doc":"","ref":"ESpec.AssertionHelpers.html#have_count_by/2"},{"type":"function","title":"ESpec.AssertionHelpers.have_first/1","doc":"","ref":"ESpec.AssertionHelpers.html#have_first/1"},{"type":"function","title":"ESpec.AssertionHelpers.have_hd/1","doc":"","ref":"ESpec.AssertionHelpers.html#have_hd/1"},{"type":"function","title":"ESpec.AssertionHelpers.have_key/1","doc":"","ref":"ESpec.AssertionHelpers.html#have_key/1"},{"type":"function","title":"ESpec.AssertionHelpers.have_last/1","doc":"","ref":"ESpec.AssertionHelpers.html#have_last/1"},{"type":"function","title":"ESpec.AssertionHelpers.have_length/1","doc":"","ref":"ESpec.AssertionHelpers.html#have_length/1"},{"type":"function","title":"ESpec.AssertionHelpers.have_max/1","doc":"","ref":"ESpec.AssertionHelpers.html#have_max/1"},{"type":"function","title":"ESpec.AssertionHelpers.have_max_by/2","doc":"","ref":"ESpec.AssertionHelpers.html#have_max_by/2"},{"type":"function","title":"ESpec.AssertionHelpers.have_min/1","doc":"","ref":"ESpec.AssertionHelpers.html#have_min/1"},{"type":"function","title":"ESpec.AssertionHelpers.have_min_by/2","doc":"","ref":"ESpec.AssertionHelpers.html#have_min_by/2"},{"type":"function","title":"ESpec.AssertionHelpers.have_size/1","doc":"","ref":"ESpec.AssertionHelpers.html#have_size/1"},{"type":"function","title":"ESpec.AssertionHelpers.have_tl/1","doc":"","ref":"ESpec.AssertionHelpers.html#have_tl/1"},{"type":"function","title":"ESpec.AssertionHelpers.have_value/1","doc":"","ref":"ESpec.AssertionHelpers.html#have_value/1"},{"type":"function","title":"ESpec.AssertionHelpers.match/1","doc":"","ref":"ESpec.AssertionHelpers.html#match/1"},{"type":"function","title":"ESpec.AssertionHelpers.match_list/1","doc":"","ref":"ESpec.AssertionHelpers.html#match_list/1"},{"type":"macro","title":"ESpec.AssertionHelpers.match_pattern/1","doc":"","ref":"ESpec.AssertionHelpers.html#match_pattern/1"},{"type":"function","title":"ESpec.AssertionHelpers.raise_exception/0","doc":"","ref":"ESpec.AssertionHelpers.html#raise_exception/0"},{"type":"function","title":"ESpec.AssertionHelpers.raise_exception/1","doc":"","ref":"ESpec.AssertionHelpers.html#raise_exception/1"},{"type":"function","title":"ESpec.AssertionHelpers.raise_exception/2","doc":"","ref":"ESpec.AssertionHelpers.html#raise_exception/2"},{"type":"function","title":"ESpec.AssertionHelpers.start_with/1","doc":"","ref":"ESpec.AssertionHelpers.html#start_with/1"},{"type":"function","title":"ESpec.AssertionHelpers.throw_term/0","doc":"","ref":"ESpec.AssertionHelpers.html#throw_term/0"},{"type":"function","title":"ESpec.AssertionHelpers.throw_term/1","doc":"","ref":"ESpec.AssertionHelpers.html#throw_term/1"},{"type":"module","title":"ESpec.Assertions.Accepted","doc":"Defines 'accepted' assertion.\n\nit do: expect(SomeModule).to accepted(:func)","ref":"ESpec.Assertions.Accepted.html"},{"type":"function","title":"ESpec.Assertions.Accepted.assert/3","doc":"","ref":"ESpec.Assertions.Accepted.html#assert/3"},{"type":"function","title":"ESpec.Assertions.Accepted.assert/4","doc":"","ref":"ESpec.Assertions.Accepted.html#assert/4"},{"type":"module","title":"ESpec.Assertions.AssertReceive","doc":"Defines 'assert_receive' and 'assert_received' assertions.\n\nit do: assert_receive :hello","ref":"ESpec.Assertions.AssertReceive.html"},{"type":"function","title":"ESpec.Assertions.AssertReceive.assert/3","doc":"","ref":"ESpec.Assertions.AssertReceive.html#assert/3"},{"type":"function","title":"ESpec.Assertions.AssertReceive.assert/4","doc":"","ref":"ESpec.Assertions.AssertReceive.html#assert/4"},{"type":"module","title":"ESpec.Assertions.Be","doc":"Defines 'be' assertion.\n\nit do: expect(2).to be :>, 1","ref":"ESpec.Assertions.Be.html"},{"type":"function","title":"ESpec.Assertions.Be.assert/3","doc":"","ref":"ESpec.Assertions.Be.html#assert/3"},{"type":"function","title":"ESpec.Assertions.Be.assert/4","doc":"","ref":"ESpec.Assertions.Be.html#assert/4"},{"type":"module","title":"ESpec.Assertions.BeBetween","doc":"Defines 'be_between' assertion.\n\nit do: expect(2).to be_between(1, 3)","ref":"ESpec.Assertions.BeBetween.html"},{"type":"function","title":"ESpec.Assertions.BeBetween.assert/3","doc":"","ref":"ESpec.Assertions.BeBetween.html#assert/3"},{"type":"function","title":"ESpec.Assertions.BeBetween.assert/4","doc":"","ref":"ESpec.Assertions.BeBetween.html#assert/4"},{"type":"module","title":"ESpec.Assertions.BeCloseTo","doc":"Defines 'be_close_to' assertion.\n\nit do: expect(2).to be_close_to(1, 3)","ref":"ESpec.Assertions.BeCloseTo.html"},{"type":"function","title":"ESpec.Assertions.BeCloseTo.assert/3","doc":"","ref":"ESpec.Assertions.BeCloseTo.html#assert/3"},{"type":"function","title":"ESpec.Assertions.BeCloseTo.assert/4","doc":"","ref":"ESpec.Assertions.BeCloseTo.html#assert/4"},{"type":"module","title":"ESpec.Assertions.BeType","doc":"Defines 'be_type' assertion.\n\nit do: expect(\"abc\").to be_binary","ref":"ESpec.Assertions.BeType.html"},{"type":"function","title":"ESpec.Assertions.BeType.assert/3","doc":"","ref":"ESpec.Assertions.BeType.html#assert/3"},{"type":"function","title":"ESpec.Assertions.BeType.assert/4","doc":"","ref":"ESpec.Assertions.BeType.html#assert/4"},{"type":"module","title":"ESpec.Assertions.Binary.HaveByteSize","doc":"Defines 'have_byte_size' assertion.\n\nit do: expect(binary).to have_byte_size(value)","ref":"ESpec.Assertions.Binary.HaveByteSize.html"},{"type":"function","title":"ESpec.Assertions.Binary.HaveByteSize.assert/3","doc":"","ref":"ESpec.Assertions.Binary.HaveByteSize.html#assert/3"},{"type":"function","title":"ESpec.Assertions.Binary.HaveByteSize.assert/4","doc":"","ref":"ESpec.Assertions.Binary.HaveByteSize.html#assert/4"},{"type":"module","title":"ESpec.Assertions.Boolean.BeFalse","doc":"Defines 'be_false' assertion.\n\nit do: expect(1 == 2).to be_false","ref":"ESpec.Assertions.Boolean.BeFalse.html"},{"type":"function","title":"ESpec.Assertions.Boolean.BeFalse.assert/3","doc":"","ref":"ESpec.Assertions.Boolean.BeFalse.html#assert/3"},{"type":"function","title":"ESpec.Assertions.Boolean.BeFalse.assert/4","doc":"","ref":"ESpec.Assertions.Boolean.BeFalse.html#assert/4"},{"type":"module","title":"ESpec.Assertions.Boolean.BeFalsy","doc":"Defines 'be_true' assertion.\n\nit do: expect(1).to be_falsy","ref":"ESpec.Assertions.Boolean.BeFalsy.html"},{"type":"function","title":"ESpec.Assertions.Boolean.BeFalsy.assert/3","doc":"","ref":"ESpec.Assertions.Boolean.BeFalsy.html#assert/3"},{"type":"function","title":"ESpec.Assertions.Boolean.BeFalsy.assert/4","doc":"","ref":"ESpec.Assertions.Boolean.BeFalsy.html#assert/4"},{"type":"module","title":"ESpec.Assertions.Boolean.BeTrue","doc":"Defines 'be_true' assertion.\n\nit do: expect(1 == 1).to be_true","ref":"ESpec.Assertions.Boolean.BeTrue.html"},{"type":"function","title":"ESpec.Assertions.Boolean.BeTrue.assert/3","doc":"","ref":"ESpec.Assertions.Boolean.BeTrue.html#assert/3"},{"type":"function","title":"ESpec.Assertions.Boolean.BeTrue.assert/4","doc":"","ref":"ESpec.Assertions.Boolean.BeTrue.html#assert/4"},{"type":"module","title":"ESpec.Assertions.Boolean.BeTruthy","doc":"Defines 'be_truthy' assertion.\n\nit do: expect(1).to be_truthy","ref":"ESpec.Assertions.Boolean.BeTruthy.html"},{"type":"function","title":"ESpec.Assertions.Boolean.BeTruthy.assert/3","doc":"","ref":"ESpec.Assertions.Boolean.BeTruthy.html#assert/3"},{"type":"function","title":"ESpec.Assertions.Boolean.BeTruthy.assert/4","doc":"","ref":"ESpec.Assertions.Boolean.BeTruthy.html#assert/4"},{"type":"module","title":"ESpec.Assertions.Change","doc":"Defines 'change' assertion.\n\nit do: expect(function1).to change(function2, to)","ref":"ESpec.Assertions.Change.html"},{"type":"function","title":"ESpec.Assertions.Change.assert/3","doc":"","ref":"ESpec.Assertions.Change.html#assert/3"},{"type":"function","title":"ESpec.Assertions.Change.assert/4","doc":"","ref":"ESpec.Assertions.Change.html#assert/4"},{"type":"module","title":"ESpec.Assertions.ChangeBy","doc":"Defines 'change' assertion.\n\nit do: expect(function1).to change(function2, [by: value])","ref":"ESpec.Assertions.ChangeBy.html"},{"type":"function","title":"ESpec.Assertions.ChangeBy.assert/3","doc":"","ref":"ESpec.Assertions.ChangeBy.html#assert/3"},{"type":"function","title":"ESpec.Assertions.ChangeBy.assert/4","doc":"","ref":"ESpec.Assertions.ChangeBy.html#assert/4"},{"type":"module","title":"ESpec.Assertions.ChangeFromTo","doc":"Defines 'change' assertion.\n\nit do: expect(function1).to change(function2, from, to)","ref":"ESpec.Assertions.ChangeFromTo.html"},{"type":"function","title":"ESpec.Assertions.ChangeFromTo.assert/3","doc":"","ref":"ESpec.Assertions.ChangeFromTo.html#assert/3"},{"type":"function","title":"ESpec.Assertions.ChangeFromTo.assert/4","doc":"","ref":"ESpec.Assertions.ChangeFromTo.html#assert/4"},{"type":"module","title":"ESpec.Assertions.ChangeTo","doc":"Defines 'change' assertion.\n\nit do: expect(function1).to change(function2, to)","ref":"ESpec.Assertions.ChangeTo.html"},{"type":"function","title":"ESpec.Assertions.ChangeTo.assert/3","doc":"","ref":"ESpec.Assertions.ChangeTo.html#assert/3"},{"type":"function","title":"ESpec.Assertions.ChangeTo.assert/4","doc":"","ref":"ESpec.Assertions.ChangeTo.html#assert/4"},{"type":"module","title":"ESpec.Assertions.ContainExactly","doc":"Defines the 'contain_exactly' assertion (or match_list) - the lists\nhave the same elements (possibly in a different order).\n\nit do: expect(actual).to contain_exactly(expected)\nit do: expect(actual).to match_list(expected)","ref":"ESpec.Assertions.ContainExactly.html"},{"type":"function","title":"ESpec.Assertions.ContainExactly.assert/3","doc":"","ref":"ESpec.Assertions.ContainExactly.html#assert/3"},{"type":"function","title":"ESpec.Assertions.ContainExactly.assert/4","doc":"","ref":"ESpec.Assertions.ContainExactly.html#assert/4"},{"type":"module","title":"ESpec.Assertions.Enum.BeEmpty","doc":"Defines 'be_empty' assertion.\n\nit do: expect(collection).to be_empty\nit do: expect(string).to be_empty","ref":"ESpec.Assertions.Enum.BeEmpty.html"},{"type":"function","title":"ESpec.Assertions.Enum.BeEmpty.assert/3","doc":"","ref":"ESpec.Assertions.Enum.BeEmpty.html#assert/3"},{"type":"function","title":"ESpec.Assertions.Enum.BeEmpty.assert/4","doc":"","ref":"ESpec.Assertions.Enum.BeEmpty.html#assert/4"},{"type":"module","title":"ESpec.Assertions.Enum.HaveAll","doc":"Defines 'have_all' assertion.\n\nit do: expect(collection).to have_all(func)","ref":"ESpec.Assertions.Enum.HaveAll.html"},{"type":"function","title":"ESpec.Assertions.Enum.HaveAll.assert/3","doc":"","ref":"ESpec.Assertions.Enum.HaveAll.html#assert/3"},{"type":"function","title":"ESpec.Assertions.Enum.HaveAll.assert/4","doc":"","ref":"ESpec.Assertions.Enum.HaveAll.html#assert/4"},{"type":"module","title":"ESpec.Assertions.Enum.HaveAny","doc":"Defines 'have_any' assertion.\n\nit do: expect(collection).to have_any(func)","ref":"ESpec.Assertions.Enum.HaveAny.html"},{"type":"function","title":"ESpec.Assertions.Enum.HaveAny.assert/3","doc":"","ref":"ESpec.Assertions.Enum.HaveAny.html#assert/3"},{"type":"function","title":"ESpec.Assertions.Enum.HaveAny.assert/4","doc":"","ref":"ESpec.Assertions.Enum.HaveAny.html#assert/4"},{"type":"module","title":"ESpec.Assertions.Enum.HaveCountBy","doc":"Defines 'have_count_by' assertion.\n\nit do: expect(collection).to have_count_by(func, value)","ref":"ESpec.Assertions.Enum.HaveCountBy.html"},{"type":"function","title":"ESpec.Assertions.Enum.HaveCountBy.assert/3","doc":"","ref":"ESpec.Assertions.Enum.HaveCountBy.html#assert/3"},{"type":"function","title":"ESpec.Assertions.Enum.HaveCountBy.assert/4","doc":"","ref":"ESpec.Assertions.Enum.HaveCountBy.html#assert/4"},{"type":"module","title":"ESpec.Assertions.Enum.HaveMax","doc":"Defines 'have_max' assertion.\n\nit do: expect(collection).to have_max(value)","ref":"ESpec.Assertions.Enum.HaveMax.html"},{"type":"function","title":"ESpec.Assertions.Enum.HaveMax.assert/3","doc":"","ref":"ESpec.Assertions.Enum.HaveMax.html#assert/3"},{"type":"function","title":"ESpec.Assertions.Enum.HaveMax.assert/4","doc":"","ref":"ESpec.Assertions.Enum.HaveMax.html#assert/4"},{"type":"module","title":"ESpec.Assertions.Enum.HaveMaxBy","doc":"Defines 'have_max_by' assertion.\n\nit do: expect(collection).to have_max_by(func, value)","ref":"ESpec.Assertions.Enum.HaveMaxBy.html"},{"type":"function","title":"ESpec.Assertions.Enum.HaveMaxBy.assert/3","doc":"","ref":"ESpec.Assertions.Enum.HaveMaxBy.html#assert/3"},{"type":"function","title":"ESpec.Assertions.Enum.HaveMaxBy.assert/4","doc":"","ref":"ESpec.Assertions.Enum.HaveMaxBy.html#assert/4"},{"type":"module","title":"ESpec.Assertions.Enum.HaveMin","doc":"Defines 'have_min' assertion.\n\nit do: expect(collection).to have_min(value)","ref":"ESpec.Assertions.Enum.HaveMin.html"},{"type":"function","title":"ESpec.Assertions.Enum.HaveMin.assert/3","doc":"","ref":"ESpec.Assertions.Enum.HaveMin.html#assert/3"},{"type":"function","title":"ESpec.Assertions.Enum.HaveMin.assert/4","doc":"","ref":"ESpec.Assertions.Enum.HaveMin.html#assert/4"},{"type":"module","title":"ESpec.Assertions.Enum.HaveMinBy","doc":"Defines 'have_min_by' assertion.\n\nit do: expect(collection).to have_min_by(func, value)","ref":"ESpec.Assertions.Enum.HaveMinBy.html"},{"type":"function","title":"ESpec.Assertions.Enum.HaveMinBy.assert/3","doc":"","ref":"ESpec.Assertions.Enum.HaveMinBy.html#assert/3"},{"type":"function","title":"ESpec.Assertions.Enum.HaveMinBy.assert/4","doc":"","ref":"ESpec.Assertions.Enum.HaveMinBy.html#assert/4"},{"type":"module","title":"ESpec.Assertions.EnumString.Have","doc":"Defines 'have' assertion.\n\nit do: expect(enum).to have(value)\n\nit do: expect(string).to have(value)","ref":"ESpec.Assertions.EnumString.Have.html"},{"type":"function","title":"ESpec.Assertions.EnumString.Have.assert/3","doc":"","ref":"ESpec.Assertions.EnumString.Have.html#assert/3"},{"type":"function","title":"ESpec.Assertions.EnumString.Have.assert/4","doc":"","ref":"ESpec.Assertions.EnumString.Have.html#assert/4"},{"type":"module","title":"ESpec.Assertions.EnumString.HaveAt","doc":"Defines 'have_at' assertion.\n\nit do: expect(enum).to have_at(pos, value)\n\nit do: expect(string).to have_at(pos, value)","ref":"ESpec.Assertions.EnumString.HaveAt.html"},{"type":"function","title":"ESpec.Assertions.EnumString.HaveAt.assert/3","doc":"","ref":"ESpec.Assertions.EnumString.HaveAt.html#assert/3"},{"type":"function","title":"ESpec.Assertions.EnumString.HaveAt.assert/4","doc":"","ref":"ESpec.Assertions.EnumString.HaveAt.html#assert/4"},{"type":"module","title":"ESpec.Assertions.EnumString.HaveCount","doc":"Defines 'have_count' assertion.\n\nit do: expect(enum).to have_count(value)\n\nit do: expect(string).to have_count(value)","ref":"ESpec.Assertions.EnumString.HaveCount.html"},{"type":"function","title":"ESpec.Assertions.EnumString.HaveCount.assert/3","doc":"","ref":"ESpec.Assertions.EnumString.HaveCount.html#assert/3"},{"type":"function","title":"ESpec.Assertions.EnumString.HaveCount.assert/4","doc":"","ref":"ESpec.Assertions.EnumString.HaveCount.html#assert/4"},{"type":"module","title":"ESpec.Assertions.Eq","doc":"Defines 'eq' (==) assertion.\n\nit do: expect(actual).to eq(expected)","ref":"ESpec.Assertions.Eq.html"},{"type":"function","title":"ESpec.Assertions.Eq.assert/3","doc":"","ref":"ESpec.Assertions.Eq.html#assert/3"},{"type":"function","title":"ESpec.Assertions.Eq.assert/4","doc":"","ref":"ESpec.Assertions.Eq.html#assert/4"},{"type":"module","title":"ESpec.Assertions.Eql","doc":"Defines 'eql' (===) assertion.\n\nit do: expect(actual).to eql(expected)","ref":"ESpec.Assertions.Eql.html"},{"type":"function","title":"ESpec.Assertions.Eql.assert/3","doc":"","ref":"ESpec.Assertions.Eql.html#assert/3"},{"type":"function","title":"ESpec.Assertions.Eql.assert/4","doc":"","ref":"ESpec.Assertions.Eql.html#assert/4"},{"type":"module","title":"ESpec.Assertions.Interface","doc":"Defines the assertion interface.\nThere are 3 functions that should be defined in the 'assertion' module:\n- `match/2`;\n- `success_message/4`;\n- `error_message/4`.","ref":"ESpec.Assertions.Interface.html"},{"type":"module","title":"ESpec.Assertions.List.HaveHd","doc":"Defines 'have_hd' assertion.\n\nit do: expect(list).to have_hd(value)","ref":"ESpec.Assertions.List.HaveHd.html"},{"type":"function","title":"ESpec.Assertions.List.HaveHd.assert/3","doc":"","ref":"ESpec.Assertions.List.HaveHd.html#assert/3"},{"type":"function","title":"ESpec.Assertions.List.HaveHd.assert/4","doc":"","ref":"ESpec.Assertions.List.HaveHd.html#assert/4"},{"type":"module","title":"ESpec.Assertions.List.HaveTl","doc":"Defines 'have_tl' assertion.\n\nit do: expect(list).to have_tl(value)","ref":"ESpec.Assertions.List.HaveTl.html"},{"type":"function","title":"ESpec.Assertions.List.HaveTl.assert/3","doc":"","ref":"ESpec.Assertions.List.HaveTl.html#assert/3"},{"type":"function","title":"ESpec.Assertions.List.HaveTl.assert/4","doc":"","ref":"ESpec.Assertions.List.HaveTl.html#assert/4"},{"type":"module","title":"ESpec.Assertions.ListString.HaveFirst","doc":"Defines 'have_first' assertion.\n\nit do: expect(list).to have_first(value)\n\nit do: expect(string).to have_first(value)","ref":"ESpec.Assertions.ListString.HaveFirst.html"},{"type":"function","title":"ESpec.Assertions.ListString.HaveFirst.assert/3","doc":"","ref":"ESpec.Assertions.ListString.HaveFirst.html#assert/3"},{"type":"function","title":"ESpec.Assertions.ListString.HaveFirst.assert/4","doc":"","ref":"ESpec.Assertions.ListString.HaveFirst.html#assert/4"},{"type":"module","title":"ESpec.Assertions.ListString.HaveLast","doc":"Defines 'have_last' assertion.\n\nit do: expect(list).to have_last(value)\n\nit do: expect(string).to have_last(value)","ref":"ESpec.Assertions.ListString.HaveLast.html"},{"type":"function","title":"ESpec.Assertions.ListString.HaveLast.assert/3","doc":"","ref":"ESpec.Assertions.ListString.HaveLast.html#assert/3"},{"type":"function","title":"ESpec.Assertions.ListString.HaveLast.assert/4","doc":"","ref":"ESpec.Assertions.ListString.HaveLast.html#assert/4"},{"type":"module","title":"ESpec.Assertions.Map.HaveKey","doc":"Defines 'have_key' assertion.\n\nit do: expect(dict).to have_key(value)","ref":"ESpec.Assertions.Map.HaveKey.html"},{"type":"function","title":"ESpec.Assertions.Map.HaveKey.assert/3","doc":"","ref":"ESpec.Assertions.Map.HaveKey.html#assert/3"},{"type":"function","title":"ESpec.Assertions.Map.HaveKey.assert/4","doc":"","ref":"ESpec.Assertions.Map.HaveKey.html#assert/4"},{"type":"module","title":"ESpec.Assertions.Map.HaveValue","doc":"Defines 'have_value' assertion.\n\nit do: expect(dict).to have_value(value)","ref":"ESpec.Assertions.Map.HaveValue.html"},{"type":"function","title":"ESpec.Assertions.Map.HaveValue.assert/3","doc":"","ref":"ESpec.Assertions.Map.HaveValue.html#assert/3"},{"type":"function","title":"ESpec.Assertions.Map.HaveValue.assert/4","doc":"","ref":"ESpec.Assertions.Map.HaveValue.html#assert/4"},{"type":"module","title":"ESpec.Assertions.Match","doc":"Defines 'match' (=~) assertion.\n\nit do: expect(actual).to match(expected)","ref":"ESpec.Assertions.Match.html"},{"type":"function","title":"ESpec.Assertions.Match.assert/3","doc":"","ref":"ESpec.Assertions.Match.html#assert/3"},{"type":"function","title":"ESpec.Assertions.Match.assert/4","doc":"","ref":"ESpec.Assertions.Match.html#assert/4"},{"type":"module","title":"ESpec.Assertions.MatchPattern","doc":"Defines 'match_pattern' (=) assertion.\n\nit do: expect(actual).to match_pattern(expected)","ref":"ESpec.Assertions.MatchPattern.html"},{"type":"function","title":"ESpec.Assertions.MatchPattern.assert/3","doc":"","ref":"ESpec.Assertions.MatchPattern.html#assert/3"},{"type":"function","title":"ESpec.Assertions.MatchPattern.assert/4","doc":"","ref":"ESpec.Assertions.MatchPattern.html#assert/4"},{"type":"module","title":"ESpec.Assertions.PID.BeAlive","doc":"Defines 'be_alive' assertion.\n\nit do: expect(self()).to be_alive","ref":"ESpec.Assertions.PID.BeAlive.html"},{"type":"function","title":"ESpec.Assertions.PID.BeAlive.assert/3","doc":"","ref":"ESpec.Assertions.PID.BeAlive.html#assert/3"},{"type":"function","title":"ESpec.Assertions.PID.BeAlive.assert/4","doc":"","ref":"ESpec.Assertions.PID.BeAlive.html#assert/4"},{"type":"module","title":"ESpec.Assertions.RaiseException","doc":"Defines 'raise_exception' assertion.\n\nit do: expect(function).to raise_exception\n\nit do: expect(function).to raise_exception(ErrorModule)\n\nit do: expect(function).to raise_exception(ErrorModule, \"message\")","ref":"ESpec.Assertions.RaiseException.html"},{"type":"function","title":"ESpec.Assertions.RaiseException.assert/3","doc":"","ref":"ESpec.Assertions.RaiseException.html#assert/3"},{"type":"function","title":"ESpec.Assertions.RaiseException.assert/4","doc":"","ref":"ESpec.Assertions.RaiseException.html#assert/4"},{"type":"module","title":"ESpec.Assertions.RefuteReceive","doc":"Defines 'refute_receive' and 'refute_received' assertions.\n\nit do: refute_receive :hello","ref":"ESpec.Assertions.RefuteReceive.html"},{"type":"function","title":"ESpec.Assertions.RefuteReceive.assert/3","doc":"","ref":"ESpec.Assertions.RefuteReceive.html#assert/3"},{"type":"function","title":"ESpec.Assertions.RefuteReceive.assert/4","doc":"","ref":"ESpec.Assertions.RefuteReceive.html#assert/4"},{"type":"module","title":"ESpec.Assertions.Result.BeErrorResult","doc":"Defines 'be_ok_result' assertion.\n\nit do: expect({:ok, :result}).to be_ok_result","ref":"ESpec.Assertions.Result.BeErrorResult.html"},{"type":"function","title":"ESpec.Assertions.Result.BeErrorResult.assert/3","doc":"","ref":"ESpec.Assertions.Result.BeErrorResult.html#assert/3"},{"type":"function","title":"ESpec.Assertions.Result.BeErrorResult.assert/4","doc":"","ref":"ESpec.Assertions.Result.BeErrorResult.html#assert/4"},{"type":"module","title":"ESpec.Assertions.Result.BeOkResult","doc":"Defines 'be_ok_result' assertion.\n\nit do: expect({:ok, :result}).to be_ok_result","ref":"ESpec.Assertions.Result.BeOkResult.html"},{"type":"function","title":"ESpec.Assertions.Result.BeOkResult.assert/3","doc":"","ref":"ESpec.Assertions.Result.BeOkResult.html#assert/3"},{"type":"function","title":"ESpec.Assertions.Result.BeOkResult.assert/4","doc":"","ref":"ESpec.Assertions.Result.BeOkResult.html#assert/4"},{"type":"module","title":"ESpec.Assertions.String.BeBlank","doc":"Defines 'be_blank' assertion.\n\nit do: expect(string).to be_blank","ref":"ESpec.Assertions.String.BeBlank.html"},{"type":"function","title":"ESpec.Assertions.String.BeBlank.assert/3","doc":"","ref":"ESpec.Assertions.String.BeBlank.html#assert/3"},{"type":"function","title":"ESpec.Assertions.String.BeBlank.assert/4","doc":"","ref":"ESpec.Assertions.String.BeBlank.html#assert/4"},{"type":"module","title":"ESpec.Assertions.String.BePrintable","doc":"Defines 'be_printable' assertion.\n\nit do: expect(string).to be_printable","ref":"ESpec.Assertions.String.BePrintable.html"},{"type":"function","title":"ESpec.Assertions.String.BePrintable.assert/3","doc":"","ref":"ESpec.Assertions.String.BePrintable.html#assert/3"},{"type":"function","title":"ESpec.Assertions.String.BePrintable.assert/4","doc":"","ref":"ESpec.Assertions.String.BePrintable.html#assert/4"},{"type":"module","title":"ESpec.Assertions.String.BeValidString","doc":"Defines 'be_valid_string' assertion.\n\nit do: expect(string).to be_valid_string","ref":"ESpec.Assertions.String.BeValidString.html"},{"type":"function","title":"ESpec.Assertions.String.BeValidString.assert/3","doc":"","ref":"ESpec.Assertions.String.BeValidString.html#assert/3"},{"type":"function","title":"ESpec.Assertions.String.BeValidString.assert/4","doc":"","ref":"ESpec.Assertions.String.BeValidString.html#assert/4"},{"type":"module","title":"ESpec.Assertions.String.EndWith","doc":"Defines 'end_with' assertion.\n\nit do: expect(string).to end_with(value)","ref":"ESpec.Assertions.String.EndWith.html"},{"type":"function","title":"ESpec.Assertions.String.EndWith.assert/3","doc":"","ref":"ESpec.Assertions.String.EndWith.html#assert/3"},{"type":"function","title":"ESpec.Assertions.String.EndWith.assert/4","doc":"","ref":"ESpec.Assertions.String.EndWith.html#assert/4"},{"type":"module","title":"ESpec.Assertions.String.StartWith","doc":"Defines 'start_with' assertion.\n\nit do: expect(string).to start_with(value)","ref":"ESpec.Assertions.String.StartWith.html"},{"type":"function","title":"ESpec.Assertions.String.StartWith.assert/3","doc":"","ref":"ESpec.Assertions.String.StartWith.html#assert/3"},{"type":"function","title":"ESpec.Assertions.String.StartWith.assert/4","doc":"","ref":"ESpec.Assertions.String.StartWith.html#assert/4"},{"type":"module","title":"ESpec.Assertions.ThrowTerm","doc":"Defines 'throw_term' assertion.\n\nit do: expect(function).to throw_term\n\nit do: expect(function).to throw_term(term)","ref":"ESpec.Assertions.ThrowTerm.html"},{"type":"function","title":"ESpec.Assertions.ThrowTerm.assert/3","doc":"","ref":"ESpec.Assertions.ThrowTerm.html#assert/3"},{"type":"function","title":"ESpec.Assertions.ThrowTerm.assert/4","doc":"","ref":"ESpec.Assertions.ThrowTerm.html#assert/4"},{"type":"module","title":"ESpec.Before","doc":"Defines 'before' macro.\nIf before block returns {:ok, key: value},\nthe {key, value} is added to an 'exapmle dict'.\nThe dict can be accessed in another `before`, in `let`,\nand in example by `shared` (`shared[:key]`).","ref":"ESpec.Before.html"},{"type":"function","title":"ESpec.Before.__struct__/0","doc":"Struct has 'spec' module name and random function name.","ref":"ESpec.Before.html#__struct__/0"},{"type":"macro","title":"ESpec.Before.before/1","doc":"Adds %ESpec.Before structs to the @context and\ndefines a function with random name which will be called when example is run.","ref":"ESpec.Before.html#before/1"},{"type":"module","title":"ESpec.BeforeAndAfterAll","doc":"Defines `before_all` and `after_all` macros.","ref":"ESpec.BeforeAndAfterAll.html"},{"type":"macro","title":"ESpec.BeforeAndAfterAll.after_all/1","doc":"Defines `after_all_function` which is run after all the specs in the module.","ref":"ESpec.BeforeAndAfterAll.html#after_all/1"},{"type":"macro","title":"ESpec.BeforeAndAfterAll.before_all/1","doc":"Defines `before_all_function` which is run before all the specs in the module.","ref":"ESpec.BeforeAndAfterAll.html#before_all/1"},{"type":"module","title":"ESpec.Configuration","doc":"Handles ESpec configurations.\n@list contains all available keys in config.","ref":"ESpec.Configuration.html"},{"type":"function","title":"ESpec.Configuration.add/1","doc":"Accepts a keyword of options.\nPuts options into application environment.\nAllows only whitelisted options.","ref":"ESpec.Configuration.html#add/1"},{"type":"function","title":"ESpec.Configuration.all/0","doc":"Returns all options.","ref":"ESpec.Configuration.html#all/0"},{"type":"function","title":"ESpec.Configuration.before/1","doc":"","ref":"ESpec.Configuration.html#before/1"},{"type":"function","title":"ESpec.Configuration.configure/1","doc":"Allows to set the config options.\nSee `ESpec.configure/1`.","ref":"ESpec.Configuration.html#configure/1"},{"type":"function","title":"ESpec.Configuration.exclude/1","doc":"","ref":"ESpec.Configuration.html#exclude/1"},{"type":"function","title":"ESpec.Configuration.file_opts/1","doc":"","ref":"ESpec.Configuration.html#file_opts/1"},{"type":"function","title":"ESpec.Configuration.finally/1","doc":"","ref":"ESpec.Configuration.html#finally/1"},{"type":"function","title":"ESpec.Configuration.finish_loading_time/1","doc":"","ref":"ESpec.Configuration.html#finish_loading_time/1"},{"type":"function","title":"ESpec.Configuration.finish_specs_time/1","doc":"","ref":"ESpec.Configuration.html#finish_specs_time/1"},{"type":"function","title":"ESpec.Configuration.focus/1","doc":"","ref":"ESpec.Configuration.html#focus/1"},{"type":"function","title":"ESpec.Configuration.formatters/1","doc":"","ref":"ESpec.Configuration.html#formatters/1"},{"type":"function","title":"ESpec.Configuration.formatters_timeout/1","doc":"","ref":"ESpec.Configuration.html#formatters_timeout/1"},{"type":"function","title":"ESpec.Configuration.get/1","doc":"Returns the value associated with key.","ref":"ESpec.Configuration.html#get/1"},{"type":"function","title":"ESpec.Configuration.hello/1","doc":"","ref":"ESpec.Configuration.html#hello/1"},{"type":"function","title":"ESpec.Configuration.only/1","doc":"","ref":"ESpec.Configuration.html#only/1"},{"type":"function","title":"ESpec.Configuration.order/1","doc":"","ref":"ESpec.Configuration.html#order/1"},{"type":"function","title":"ESpec.Configuration.out_file/1","doc":"","ref":"ESpec.Configuration.html#out_file/1"},{"type":"function","title":"ESpec.Configuration.seed/1","doc":"","ref":"ESpec.Configuration.html#seed/1"},{"type":"function","title":"ESpec.Configuration.shared_specs/1","doc":"","ref":"ESpec.Configuration.html#shared_specs/1"},{"type":"function","title":"ESpec.Configuration.silent/1","doc":"","ref":"ESpec.Configuration.html#silent/1"},{"type":"function","title":"ESpec.Configuration.stale/1","doc":"","ref":"ESpec.Configuration.html#stale/1"},{"type":"function","title":"ESpec.Configuration.start_loading_time/1","doc":"","ref":"ESpec.Configuration.html#start_loading_time/1"},{"type":"function","title":"ESpec.Configuration.string/1","doc":"","ref":"ESpec.Configuration.html#string/1"},{"type":"function","title":"ESpec.Configuration.sync/1","doc":"","ref":"ESpec.Configuration.html#sync/1"},{"type":"function","title":"ESpec.Configuration.test/1","doc":"","ref":"ESpec.Configuration.html#test/1"},{"type":"function","title":"ESpec.Configuration.trace/1","doc":"","ref":"ESpec.Configuration.html#trace/1"},{"type":"module","title":"ESpec.Context","doc":"Defines macros 'context', 'describe', and 'example_group'.\nDefines macros for 'skip' and 'focus' example groups","ref":"ESpec.Context.html"},{"type":"function","title":"ESpec.Context.__struct__/0","doc":"Context has description, line, and options.\nAvailable options are:\n- [skip: true] or [skip: \"Reason\"] - skips examples in the context;\n- [focus: true] - sets focus to run with `--focus ` option.","ref":"ESpec.Context.html#__struct__/0"},{"type":"macro","title":"ESpec.Context.context/1","doc":"","ref":"ESpec.Context.html#context/1"},{"type":"macro","title":"ESpec.Context.context/2","doc":"","ref":"ESpec.Context.html#context/2"},{"type":"macro","title":"ESpec.Context.context/3","doc":"Add context with description and opts to 'example context'.","ref":"ESpec.Context.html#context/3"},{"type":"macro","title":"ESpec.Context.describe/1","doc":"","ref":"ESpec.Context.html#describe/1"},{"type":"macro","title":"ESpec.Context.describe/2","doc":"","ref":"ESpec.Context.html#describe/2"},{"type":"macro","title":"ESpec.Context.describe/3","doc":"Aliases for `context`.","ref":"ESpec.Context.html#describe/3"},{"type":"macro","title":"ESpec.Context.example_group/1","doc":"","ref":"ESpec.Context.html#example_group/1"},{"type":"macro","title":"ESpec.Context.example_group/2","doc":"","ref":"ESpec.Context.html#example_group/2"},{"type":"macro","title":"ESpec.Context.example_group/3","doc":"","ref":"ESpec.Context.html#example_group/3"},{"type":"macro","title":"ESpec.Context.fcontext/1","doc":"","ref":"ESpec.Context.html#fcontext/1"},{"type":"macro","title":"ESpec.Context.fcontext/2","doc":"","ref":"ESpec.Context.html#fcontext/2"},{"type":"macro","title":"ESpec.Context.fcontext/3","doc":"Macros for focused contexts","ref":"ESpec.Context.html#fcontext/3"},{"type":"macro","title":"ESpec.Context.fdescribe/1","doc":"","ref":"ESpec.Context.html#fdescribe/1"},{"type":"macro","title":"ESpec.Context.fdescribe/2","doc":"","ref":"ESpec.Context.html#fdescribe/2"},{"type":"macro","title":"ESpec.Context.fdescribe/3","doc":"","ref":"ESpec.Context.html#fdescribe/3"},{"type":"macro","title":"ESpec.Context.fexample_group/1","doc":"","ref":"ESpec.Context.html#fexample_group/1"},{"type":"macro","title":"ESpec.Context.fexample_group/2","doc":"","ref":"ESpec.Context.html#fexample_group/2"},{"type":"macro","title":"ESpec.Context.fexample_group/3","doc":"","ref":"ESpec.Context.html#fexample_group/3"},{"type":"macro","title":"ESpec.Context.xcontext/1","doc":"","ref":"ESpec.Context.html#xcontext/1"},{"type":"macro","title":"ESpec.Context.xcontext/2","doc":"","ref":"ESpec.Context.html#xcontext/2"},{"type":"macro","title":"ESpec.Context.xcontext/3","doc":"Macros for skipped contexts","ref":"ESpec.Context.html#xcontext/3"},{"type":"macro","title":"ESpec.Context.xdescribe/1","doc":"","ref":"ESpec.Context.html#xdescribe/1"},{"type":"macro","title":"ESpec.Context.xdescribe/2","doc":"","ref":"ESpec.Context.html#xdescribe/2"},{"type":"macro","title":"ESpec.Context.xdescribe/3","doc":"","ref":"ESpec.Context.html#xdescribe/3"},{"type":"macro","title":"ESpec.Context.xexample_group/1","doc":"","ref":"ESpec.Context.html#xexample_group/1"},{"type":"macro","title":"ESpec.Context.xexample_group/2","doc":"","ref":"ESpec.Context.html#xexample_group/2"},{"type":"macro","title":"ESpec.Context.xexample_group/3","doc":"","ref":"ESpec.Context.html#xexample_group/3"},{"type":"protocol","title":"ESpec.DatesTimes.DateTimeProtocol","doc":"This protocol defines the API for functions which take a `Date`,\n`NaiveDateTime`, or `DateTime` as input.","ref":"ESpec.DatesTimes.DateTimeProtocol.html"},{"type":"type","title":"ESpec.DatesTimes.DateTimeProtocol.t/0","doc":"All the types that implement this protocol.","ref":"ESpec.DatesTimes.DateTimeProtocol.html#t:t/0"},{"type":"function","title":"ESpec.DatesTimes.DateTimeProtocol.to_comparison_units/1","doc":"Convert a date/time value to gregorian microseconds (microseconds since the start of year zero)","ref":"ESpec.DatesTimes.DateTimeProtocol.html#to_comparison_units/1"},{"type":"module","title":"ESpec.DatesTimes.Delegator","doc":"The ESpec.DateTimes.Delegator module. Used to delegate methods to the correct protocol\nimplementation.","ref":"ESpec.DatesTimes.Delegator.html"},{"type":"function","title":"ESpec.DatesTimes.Delegator.to_comparison_units/1","doc":"Convert a date/time value to (gregorian) microseconds\n(microseconds since start of year zero if gregorian)","ref":"ESpec.DatesTimes.Delegator.html#to_comparison_units/1"},{"type":"module","title":"ESpec.DatesTimes.Types","doc":"","ref":"ESpec.DatesTimes.Types.html"},{"type":"type","title":"ESpec.DatesTimes.Types.calendar_types/0","doc":"","ref":"ESpec.DatesTimes.Types.html#t:calendar_types/0"},{"type":"type","title":"ESpec.DatesTimes.Types.time_units/0","doc":"","ref":"ESpec.DatesTimes.Types.html#t:time_units/0"},{"type":"module","title":"ESpec.DescribedModule","doc":"Defines the 'described_module' helper which makes accessing tested module possible.\nKeep in mind the convention 'module TheModuleSpec is spec for TheModule'","ref":"ESpec.DescribedModule.html"},{"type":"module","title":"ESpec.Diff","doc":"","ref":"ESpec.Diff.html"},{"type":"function","title":"ESpec.Diff.diff/2","doc":"","ref":"ESpec.Diff.html#diff/2"},{"type":"module","title":"ESpec.DocExample","doc":"Defines the 'extract' method with parse module content and return `%ESpec.DocExample{}` structs.\nThe struct is used by 'ESpec.DocTest' module to build the specs.","ref":"ESpec.DocExample.html"},{"type":"function","title":"ESpec.DocExample.__struct__/0","doc":"DocExample struct:\nlhs - console input,\nrhs - console output,\nfun_arity - {fun, arity} tuple,\nline - line where function is definde,\ntype - define the doc spec type (:test, :error or :inspect).\nRead 'ESpec.DocTest' doc for more info.","ref":"ESpec.DocExample.html#__struct__/0"},{"type":"function","title":"ESpec.DocExample.extract/1","doc":"Extract module docs and returns a list of %ESpec.DocExample{} structs","ref":"ESpec.DocExample.html#extract/1"},{"type":"function","title":"ESpec.DocExample.to_struct/1","doc":"","ref":"ESpec.DocExample.html#to_struct/1"},{"type":"module","title":"ESpec.DocTest","doc":"Implements functionality similar to ExUnit.DocTest.\nProvides doctest macro.\nRead the ExUnit.DocTest documentation for more info.\n\nThere are three types of specs:\n:test - examples where input and output can be evaluated:\n  iex> Enum.map [1, 2, 3], fn(x) ->\n  ...>   x * 2\n  ...> end\n  [2,4,6]\n  Such examples will be converted to: 'expect(input).to eq(output)' assertion.\n\n:inspect - examples which return complex structure so Elixir prints it as #Name<...>.\n  iex> Enum.into([a: 10, b: 20], HashDict.new)\n  #HashDict<[b: 20, a: 10]>\n  The examples will be converted to: 'expect(inspect input).to eq(output)'.\n\n:error - examples with exceptions:\n  iex(1)> String.to_atom((fn() -> 1 end).())\n  ** (ArgumentError) argument error\n  The examples will be converted to: expect(fn -> input end).to raise_exception(error_module, error_message).","ref":"ESpec.DocTest.html"},{"type":"macro","title":"ESpec.DocTest.doctest/2","doc":"Parses the module and builds 'specs'.","ref":"ESpec.DocTest.html#doctest/2"},{"type":"module","title":"ESpec.Example","doc":"Defines macros 'example' and 'it'.\nThese macros defines function with random name which will be called when example runs.\nExample structs %ESpec.Example are accumulated in @examples attribute","ref":"ESpec.Example.html"},{"type":"function","title":"ESpec.Example.__struct__/0","doc":"Example struct.\ndescription - the description of example,\nmodule - spec module,\nfunction - random function name,\nopts - options,\nfile - spec file path,\nline - the line where example is defined,\ncontext - example context. Accumulator for 'contexts' and 'lets',\nshared - marks example as shared,\nstatus - example status (:new, :success, :failure, :pending),\nresult - the value returned by example block or the pending message,\nerror - store an error,\nduration - test duration.","ref":"ESpec.Example.html#__struct__/0"},{"type":"function","title":"ESpec.Example.context_descriptions/1","doc":"Context descriptions.","ref":"ESpec.Example.html#context_descriptions/1"},{"type":"function","title":"ESpec.Example.extract/2","doc":"","ref":"ESpec.Example.html#extract/2"},{"type":"function","title":"ESpec.Example.extract_all_options/1","doc":"Extracts example options from most specific to least specific as Keyword list. Can include duplicates.","ref":"ESpec.Example.html#extract_all_options/1"},{"type":"function","title":"ESpec.Example.extract_befores/1","doc":"Extracts specific structs from example context.","ref":"ESpec.Example.html#extract_befores/1"},{"type":"function","title":"ESpec.Example.extract_contexts/1","doc":"","ref":"ESpec.Example.html#extract_contexts/1"},{"type":"function","title":"ESpec.Example.extract_finallies/1","doc":"","ref":"ESpec.Example.html#extract_finallies/1"},{"type":"function","title":"ESpec.Example.extract_lets/1","doc":"","ref":"ESpec.Example.html#extract_lets/1"},{"type":"function","title":"ESpec.Example.extract_option/2","doc":"Extracts example option.","ref":"ESpec.Example.html#extract_option/2"},{"type":"function","title":"ESpec.Example.extract_options/1","doc":"Extracts example options as they are currently valid for this example as map.","ref":"ESpec.Example.html#extract_options/1"},{"type":"function","title":"ESpec.Example.failure/1","doc":"Filters failed examples.","ref":"ESpec.Example.html#failure/1"},{"type":"function","title":"ESpec.Example.pending_message/1","doc":"Message for pending examples.","ref":"ESpec.Example.html#pending_message/1"},{"type":"function","title":"ESpec.Example.pendings/1","doc":"Filters pending examples.","ref":"ESpec.Example.html#pendings/1"},{"type":"function","title":"ESpec.Example.skip_message/1","doc":"Message for skipped examples.","ref":"ESpec.Example.html#skip_message/1"},{"type":"function","title":"ESpec.Example.success/1","doc":"Filters success examples.","ref":"ESpec.Example.html#success/1"},{"type":"type","title":"ESpec.Example.t/0","doc":"","ref":"ESpec.Example.html#t:t/0"},{"type":"module","title":"ESpec.ExampleHelpers","doc":"Defines macros 'example' and 'it'.\nThese macros defines function with random name which will be called when example runs.\nExample structs %ESpec.Example are accumulated in @examples attribute","ref":"ESpec.ExampleHelpers.html"},{"type":"macro","title":"ESpec.ExampleHelpers.example/1","doc":"Macros for pending exaples.","ref":"ESpec.ExampleHelpers.html#example/1"},{"type":"macro","title":"ESpec.ExampleHelpers.example/2","doc":"","ref":"ESpec.ExampleHelpers.html#example/2"},{"type":"macro","title":"ESpec.ExampleHelpers.example/3","doc":"Adds example to @examples and defines function to wrap the spec.\nSends `shared`' variable to the example block.","ref":"ESpec.ExampleHelpers.html#example/3"},{"type":"macro","title":"ESpec.ExampleHelpers.fexample/1","doc":"","ref":"ESpec.ExampleHelpers.html#fexample/1"},{"type":"macro","title":"ESpec.ExampleHelpers.fexample/2","doc":"","ref":"ESpec.ExampleHelpers.html#fexample/2"},{"type":"macro","title":"ESpec.ExampleHelpers.fexample/3","doc":"","ref":"ESpec.ExampleHelpers.html#fexample/3"},{"type":"macro","title":"ESpec.ExampleHelpers.fit/1","doc":"","ref":"ESpec.ExampleHelpers.html#fit/1"},{"type":"macro","title":"ESpec.ExampleHelpers.fit/2","doc":"","ref":"ESpec.ExampleHelpers.html#fit/2"},{"type":"macro","title":"ESpec.ExampleHelpers.fit/3","doc":"Macros for focused examples.","ref":"ESpec.ExampleHelpers.html#fit/3"},{"type":"macro","title":"ESpec.ExampleHelpers.focus/1","doc":"","ref":"ESpec.ExampleHelpers.html#focus/1"},{"type":"macro","title":"ESpec.ExampleHelpers.focus/2","doc":"","ref":"ESpec.ExampleHelpers.html#focus/2"},{"type":"macro","title":"ESpec.ExampleHelpers.focus/3","doc":"","ref":"ESpec.ExampleHelpers.html#focus/3"},{"type":"macro","title":"ESpec.ExampleHelpers.fspecify/1","doc":"","ref":"ESpec.ExampleHelpers.html#fspecify/1"},{"type":"macro","title":"ESpec.ExampleHelpers.fspecify/2","doc":"","ref":"ESpec.ExampleHelpers.html#fspecify/2"},{"type":"macro","title":"ESpec.ExampleHelpers.fspecify/3","doc":"","ref":"ESpec.ExampleHelpers.html#fspecify/3"},{"type":"macro","title":"ESpec.ExampleHelpers.include_examples/2","doc":"alias for include_examples","ref":"ESpec.ExampleHelpers.html#include_examples/2"},{"type":"macro","title":"ESpec.ExampleHelpers.it/1","doc":"","ref":"ESpec.ExampleHelpers.html#it/1"},{"type":"macro","title":"ESpec.ExampleHelpers.it/2","doc":"","ref":"ESpec.ExampleHelpers.html#it/2"},{"type":"macro","title":"ESpec.ExampleHelpers.it/3","doc":"Aliases for `example`","ref":"ESpec.ExampleHelpers.html#it/3"},{"type":"macro","title":"ESpec.ExampleHelpers.it_behaves_like/2","doc":"Defines examples using another module.","ref":"ESpec.ExampleHelpers.html#it_behaves_like/2"},{"type":"macro","title":"ESpec.ExampleHelpers.pending/1","doc":"","ref":"ESpec.ExampleHelpers.html#pending/1"},{"type":"function","title":"ESpec.ExampleHelpers.random_atom/1","doc":"","ref":"ESpec.ExampleHelpers.html#random_atom/1"},{"type":"macro","title":"ESpec.ExampleHelpers.specify/1","doc":"","ref":"ESpec.ExampleHelpers.html#specify/1"},{"type":"macro","title":"ESpec.ExampleHelpers.specify/2","doc":"","ref":"ESpec.ExampleHelpers.html#specify/2"},{"type":"macro","title":"ESpec.ExampleHelpers.specify/3","doc":"","ref":"ESpec.ExampleHelpers.html#specify/3"},{"type":"macro","title":"ESpec.ExampleHelpers.xexample/1","doc":"","ref":"ESpec.ExampleHelpers.html#xexample/1"},{"type":"macro","title":"ESpec.ExampleHelpers.xexample/2","doc":"","ref":"ESpec.ExampleHelpers.html#xexample/2"},{"type":"macro","title":"ESpec.ExampleHelpers.xexample/3","doc":"","ref":"ESpec.ExampleHelpers.html#xexample/3"},{"type":"macro","title":"ESpec.ExampleHelpers.xit/1","doc":"","ref":"ESpec.ExampleHelpers.html#xit/1"},{"type":"macro","title":"ESpec.ExampleHelpers.xit/2","doc":"","ref":"ESpec.ExampleHelpers.html#xit/2"},{"type":"macro","title":"ESpec.ExampleHelpers.xit/3","doc":"Macros for skipped examples.","ref":"ESpec.ExampleHelpers.html#xit/3"},{"type":"macro","title":"ESpec.ExampleHelpers.xspecify/1","doc":"","ref":"ESpec.ExampleHelpers.html#xspecify/1"},{"type":"macro","title":"ESpec.ExampleHelpers.xspecify/2","doc":"","ref":"ESpec.ExampleHelpers.html#xspecify/2"},{"type":"macro","title":"ESpec.ExampleHelpers.xspecify/3","doc":"","ref":"ESpec.ExampleHelpers.html#xspecify/3"},{"type":"module","title":"ESpec.ExampleRunner","doc":"Contains all the functions need to run a 'spec' example.","ref":"ESpec.ExampleRunner.html"},{"type":"function","title":"ESpec.ExampleRunner.after_example_actions/2","doc":"","ref":"ESpec.ExampleRunner.html#after_example_actions/2"},{"type":"function","title":"ESpec.ExampleRunner.run/1","doc":"Runs one specific example and returns an `%ESpec.Example{}` struct.\nThe sequence in the following:\n- evaluates 'befores' and 'lets'. 'befores' fill the map for `shared`, 'lets' can access `shared` ;\n- runs 'example block';\n- evaluate 'finally's'\nThe struct has fields `[status: :success, result: result]` or `[status: failed, error: error]`\nThe `result` is the value returned by example block.\n`error` is a `%ESpec.AssertionError{}` struct.","ref":"ESpec.ExampleRunner.html#run/1"},{"type":"module","title":"ESpec.Expect","doc":"Defines `expect` and `is_expected` helper functions.\nThese functions wrap arguments for ESpec.ExpectTo module.","ref":"ESpec.Expect.html"},{"type":"function","title":"ESpec.Expect.expect/1","doc":"Wrapper for `ESpec.ExpectTo`.","ref":"ESpec.Expect.html#expect/1"},{"type":"function","title":"ESpec.Expect.pruned_stacktrace/0","doc":"","ref":"ESpec.Expect.html#pruned_stacktrace/0"},{"type":"module","title":"ESpec.ExpectTo","doc":"Defines `to` and `to_not` functions which call specific 'assertion'","ref":"ESpec.ExpectTo.html"},{"type":"function","title":"ESpec.ExpectTo.not_to/2","doc":"Alias of `to_not`.","ref":"ESpec.ExpectTo.html#not_to/2"},{"type":"function","title":"ESpec.ExpectTo.to/2","doc":"Calls specific assertion.","ref":"ESpec.ExpectTo.html#to/2"},{"type":"function","title":"ESpec.ExpectTo.to_not/2","doc":"Just apply 'assert' with `positive = false`.","ref":"ESpec.ExpectTo.html#to_not/2"},{"type":"module","title":"ESpec.Finally","doc":"Defines `finally` macro.\nThe block is evaluated after the example.\n`shared` is available.\nDefine the `finally` before example!.","ref":"ESpec.Finally.html"},{"type":"function","title":"ESpec.Finally.__struct__/0","doc":"Struct has random fuction name.","ref":"ESpec.Finally.html#__struct__/0"},{"type":"macro","title":"ESpec.Finally.finally/1","doc":"Adds %ESpec.Finally structs to the context and\ndefines random function with random name which will be called when example is run.","ref":"ESpec.Finally.html#finally/1"},{"type":"module","title":"ESpec.Formatters.Base","doc":"","ref":"ESpec.Formatters.Base.html"},{"type":"module","title":"ESpec.Formatters.Doc","doc":"Generates plain colored text output.","ref":"ESpec.Formatters.Doc.html"},{"type":"function","title":"ESpec.Formatters.Doc.child_spec/1","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"ESpec.Formatters.Doc.html#child_spec/1"},{"type":"function","title":"ESpec.Formatters.Doc.format_example/2","doc":"Formats an example result.","ref":"ESpec.Formatters.Doc.html#format_example/2"},{"type":"function","title":"ESpec.Formatters.Doc.format_result/3","doc":"Formats the final result.","ref":"ESpec.Formatters.Doc.html#format_result/3"},{"type":"function","title":"ESpec.Formatters.Doc.init/1","doc":"Callback implementation for  GenServer.init/1 .","ref":"ESpec.Formatters.Doc.html#init/1"},{"type":"module","title":"ESpec.Formatters.Html","doc":"Generates html output.","ref":"ESpec.Formatters.Html.html"},{"type":"function","title":"ESpec.Formatters.Html.child_spec/1","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"ESpec.Formatters.Html.html#child_spec/1"},{"type":"function","title":"ESpec.Formatters.Html.format_example/2","doc":"Formats an example result.","ref":"ESpec.Formatters.Html.html#format_example/2"},{"type":"function","title":"ESpec.Formatters.Html.format_result/3","doc":"Format the final result.","ref":"ESpec.Formatters.Html.html#format_result/3"},{"type":"function","title":"ESpec.Formatters.Html.init/1","doc":"Callback implementation for  GenServer.init/1 .","ref":"ESpec.Formatters.Html.html#init/1"},{"type":"module","title":"ESpec.Formatters.Json","doc":"Generates json output.","ref":"ESpec.Formatters.Json.html"},{"type":"function","title":"ESpec.Formatters.Json.child_spec/1","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"ESpec.Formatters.Json.html#child_spec/1"},{"type":"function","title":"ESpec.Formatters.Json.format_example/2","doc":"Formats an example result.","ref":"ESpec.Formatters.Json.html#format_example/2"},{"type":"function","title":"ESpec.Formatters.Json.format_result/3","doc":"Formats the final result.","ref":"ESpec.Formatters.Json.html#format_result/3"},{"type":"function","title":"ESpec.Formatters.Json.format_success/1","doc":"","ref":"ESpec.Formatters.Json.html#format_success/1"},{"type":"function","title":"ESpec.Formatters.Json.format_summary/4","doc":"","ref":"ESpec.Formatters.Json.html#format_summary/4"},{"type":"function","title":"ESpec.Formatters.Json.init/1","doc":"Callback implementation for  GenServer.init/1 .","ref":"ESpec.Formatters.Json.html#init/1"},{"type":"module","title":"ESpec.Formatters.WriteOutput","doc":"","ref":"ESpec.Formatters.WriteOutput.html"},{"type":"function","title":"ESpec.Formatters.WriteOutput.close_out_file/1","doc":"","ref":"ESpec.Formatters.WriteOutput.html#close_out_file/1"},{"type":"function","title":"ESpec.Formatters.WriteOutput.create_out_file!/1","doc":"","ref":"ESpec.Formatters.WriteOutput.html#create_out_file!/1"},{"type":"function","title":"ESpec.Formatters.WriteOutput.write_output/2","doc":"","ref":"ESpec.Formatters.WriteOutput.html#write_output/2"},{"type":"module","title":"ESpec.Let","doc":"Defines 'let', 'let!' and 'subject' macros.\n'let' and 'let!' macros define named functions with cached return values.\nThe 'let' evaluate block in runtime when called first time.\nThe 'let!' evaluates as a before block just after all 'befores' for example.\nThe 'subject' macro is just an alias for let to define `subject`.","ref":"ESpec.Let.html"},{"type":"function","title":"ESpec.Let.__struct__/0","doc":"Struct keeps the name of variable and random function name.","ref":"ESpec.Let.html#__struct__/0"},{"type":"macro","title":"ESpec.Let.let/1","doc":"Allows to define several 'lets' at once","ref":"ESpec.Let.html#let/1"},{"type":"macro","title":"ESpec.Let.let/2","doc":"The macro defines function with random name which returns block value.\nThat function will be called when example is run.\nThe function will place the block value to the Agent dict.","ref":"ESpec.Let.html#let/2"},{"type":"macro","title":"ESpec.Let.let!/1","doc":"Allows to define several 'lets' at once","ref":"ESpec.Let.html#let!/1"},{"type":"macro","title":"ESpec.Let.let!/2","doc":"let! evaluate block like `before`","ref":"ESpec.Let.html#let!/2"},{"type":"macro","title":"ESpec.Let.let_error/1","doc":"","ref":"ESpec.Let.html#let_error/1"},{"type":"macro","title":"ESpec.Let.let_error/2","doc":"Defines 'let' for error result tuple.","ref":"ESpec.Let.html#let_error/2"},{"type":"macro","title":"ESpec.Let.let_error!/1","doc":"","ref":"ESpec.Let.html#let_error!/1"},{"type":"macro","title":"ESpec.Let.let_error!/2","doc":"Defines 'let!' for error result tuple.","ref":"ESpec.Let.html#let_error!/2"},{"type":"macro","title":"ESpec.Let.let_ok/1","doc":"","ref":"ESpec.Let.html#let_ok/1"},{"type":"macro","title":"ESpec.Let.let_ok/2","doc":"Defines 'let' for success result tuple.","ref":"ESpec.Let.html#let_ok/2"},{"type":"macro","title":"ESpec.Let.let_ok!/1","doc":"","ref":"ESpec.Let.html#let_ok!/1"},{"type":"macro","title":"ESpec.Let.let_ok!/2","doc":"Defines 'let!' for success result tuple.","ref":"ESpec.Let.html#let_ok!/2"},{"type":"macro","title":"ESpec.Let.let_overridable/1","doc":"Defines overridable lets in shared examples","ref":"ESpec.Let.html#let_overridable/1"},{"type":"macro","title":"ESpec.Let.subject/1","doc":"Defines 'subject'.","ref":"ESpec.Let.html#subject/1"},{"type":"macro","title":"ESpec.Let.subject/2","doc":"","ref":"ESpec.Let.html#subject/2"},{"type":"macro","title":"ESpec.Let.subject!/1","doc":"Defines 'subject!'.","ref":"ESpec.Let.html#subject!/1"},{"type":"macro","title":"ESpec.Let.subject!/2","doc":"","ref":"ESpec.Let.html#subject!/2"},{"type":"module","title":"ESpec.Let.Impl","doc":"'let' implementation is here.","ref":"ESpec.Let.Impl.html"},{"type":"function","title":"ESpec.Let.Impl.clear_lets/1","doc":"Clears all let values for the given module. Called by ExampleRunner.","ref":"ESpec.Let.Impl.html#clear_lets/1"},{"type":"function","title":"ESpec.Let.Impl.let_eval/2","doc":"This function is used by the let macro to implement lazy evaluation","ref":"ESpec.Let.Impl.html#let_eval/2"},{"type":"function","title":"ESpec.Let.Impl.random_let_name/0","doc":"","ref":"ESpec.Let.Impl.html#random_let_name/0"},{"type":"function","title":"ESpec.Let.Impl.run_before/1","doc":"Resets stored let value and prepares for evaluation. Called by ExampleRunner.","ref":"ESpec.Let.Impl.html#run_before/1"},{"type":"function","title":"ESpec.Let.Impl.start_agent/0","doc":"Starts Agent to save state of 'lets'.","ref":"ESpec.Let.Impl.html#start_agent/0"},{"type":"function","title":"ESpec.Let.Impl.stop_agent/0","doc":"Stops Agent","ref":"ESpec.Let.Impl.html#stop_agent/0"},{"type":"function","title":"ESpec.Let.Impl.update_shared/1","doc":"Updates the shared map that is available to let blocks. Called by ExampleRunner.","ref":"ESpec.Let.Impl.html#update_shared/1"},{"type":"module","title":"ESpec.Mock","doc":"Defines 'expect` function to mock function using 'meck'.\n:meck.new is called with options :non_strict and :passthrough.\nThe :non_strict allows create mocks for modules and functions that do not exist.\nThe :passthrough options allow call other functions in the module.\nInformation about mock is stored in the ':espec_mock_agent' set.\nMock are being unloaded after each example.","ref":"ESpec.Mock.html"},{"type":"function","title":"ESpec.Mock.expect/4","doc":"Creates new mock using :meck. The default :meck options are [:non_strict, :passthrough]\nbut they can be overriden.\nStores mock in agent to remove it after spec.","ref":"ESpec.Mock.html#expect/4"},{"type":"function","title":"ESpec.Mock.start_agent/0","doc":"Starts Agent to save mocked modules.","ref":"ESpec.Mock.html#start_agent/0"},{"type":"function","title":"ESpec.Mock.stop_agent/0","doc":"Stops Agent","ref":"ESpec.Mock.html#stop_agent/0"},{"type":"function","title":"ESpec.Mock.unload/0","doc":"Unloads modules at the end of example","ref":"ESpec.Mock.html#unload/0"},{"type":"module","title":"ESpec.Output","doc":"Provides functions for output of spec results.\nUses specified formatter to format results.","ref":"ESpec.Output.html"},{"type":"function","title":"ESpec.Output.child_spec/1","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"ESpec.Output.html#child_spec/1"},{"type":"function","title":"ESpec.Output.example_finished/1","doc":"Generates example info.","ref":"ESpec.Output.html#example_finished/1"},{"type":"function","title":"ESpec.Output.final_result/1","doc":"Generates suite info","ref":"ESpec.Output.html#final_result/1"},{"type":"function","title":"ESpec.Output.init/1","doc":"Initiates server with configuration options and formatter","ref":"ESpec.Output.html#init/1"},{"type":"function","title":"ESpec.Output.start/0","doc":"Starts server.","ref":"ESpec.Output.html#start/0"},{"type":"module","title":"ESpec.RefuteReceive","doc":"Defines `refute_receive` and `refute_received` helper macros","ref":"ESpec.RefuteReceive.html"},{"type":"macro","title":"ESpec.RefuteReceive.refute_receive/2","doc":"Asserts that a message matching `pattern` was not received (and won't be received) within the `timeout` period.","ref":"ESpec.RefuteReceive.html#refute_receive/2"},{"type":"macro","title":"ESpec.RefuteReceive.refute_received/1","doc":"Asserts a message matching `pattern` was not received (i.e. it is not in the current process' mailbox)","ref":"ESpec.RefuteReceive.html#refute_received/1"},{"type":"module","title":"ESpec.Runner","doc":"Defines functions which runs the examples.\nUses GenServer behavior.","ref":"ESpec.Runner.html"},{"type":"function","title":"ESpec.Runner.run/0","doc":"Runs all examples.","ref":"ESpec.Runner.html#run/0"},{"type":"function","title":"ESpec.Runner.start/0","doc":"Starts the `ESpec.Runner` server","ref":"ESpec.Runner.html#start/0"},{"type":"module","title":"ESpec.Runner.Queue","doc":"Implements queue.","ref":"ESpec.Runner.Queue.html"},{"type":"function","title":"ESpec.Runner.Queue.all/1","doc":"","ref":"ESpec.Runner.Queue.html#all/1"},{"type":"function","title":"ESpec.Runner.Queue.clear/1","doc":"","ref":"ESpec.Runner.Queue.html#clear/1"},{"type":"function","title":"ESpec.Runner.Queue.pop/1","doc":"","ref":"ESpec.Runner.Queue.html#pop/1"},{"type":"function","title":"ESpec.Runner.Queue.push/2","doc":"","ref":"ESpec.Runner.Queue.html#push/2"},{"type":"function","title":"ESpec.Runner.Queue.start/1","doc":"","ref":"ESpec.Runner.Queue.html#start/1"},{"type":"function","title":"ESpec.Runner.Queue.stop/1","doc":"","ref":"ESpec.Runner.Queue.html#stop/1"},{"type":"module","title":"ESpec.Should","doc":"Defines `should` and `should_not` helpers.","ref":"ESpec.Should.html"},{"type":"function","title":"ESpec.Should.should/2","doc":"Wrapper for `ESpec.ExpectTo`.","ref":"ESpec.Should.html#should/2"},{"type":"function","title":"ESpec.Should.should_not/2","doc":"","ref":"ESpec.Should.html#should_not/2"},{"type":"module","title":"ESpec.SuiteRunner","doc":"Defines functions for running specs in modules.","ref":"ESpec.SuiteRunner.html"},{"type":"function","title":"ESpec.SuiteRunner.run/3","doc":"Runs `before_all` hook, examples and then `after_all` hook.","ref":"ESpec.SuiteRunner.html#run/3"},{"type":"function","title":"ESpec.SuiteRunner.run_examples/2","doc":"Runs examples.","ref":"ESpec.SuiteRunner.html#run_examples/2"},{"type":"module","title":"ESpec.Support","doc":"Contains come functions for generating random function names.","ref":"ESpec.Support.html"},{"type":"function","title":"ESpec.Support.random_string/0","doc":"Returns long random string.","ref":"ESpec.Support.html#random_string/0"},{"type":"function","title":"ESpec.Support.word_chars/1","doc":"Filters string replacing non-word characters by '_'.","ref":"ESpec.Support.html#word_chars/1"},{"type":"module","title":"ESpec.To","doc":"Defines `to`, `to_not` and `not_to` helper functions.\nThe functions implement syntax: 'expect 1 |> to eq 1'\nThese functions wrap arguments for `ESpec.ExpectTo` module.\n\nAlso defines `to` helper function for mocking without parenthesis:\n`allow SomeModule |> to accept(:f, fn(a) -> \"mock\" end)`\nThese functions wrap arguments for `ESpec.AllowTo` module.","ref":"ESpec.To.html"},{"type":"function","title":"ESpec.To.not_to/2","doc":"","ref":"ESpec.To.html#not_to/2"},{"type":"function","title":"ESpec.To.to/2","doc":"Wrappers for `ESpec.AllowTo.to`.","ref":"ESpec.To.html#to/2"},{"type":"function","title":"ESpec.To.to_not/2","doc":"","ref":"ESpec.To.html#to_not/2"},{"type":"module","title":"Integer.Extension","doc":"A module to extend the calendar implementation that follows to ISO8601 with methods found in\nElixir 1.5.1. This is to allow ESpec to support Elixir >= 1.3.4 more easily.","ref":"Integer.Extension.html"},{"type":"function","title":"Integer.Extension.floor_div/2","doc":"Performs a floored integer division.\n\nRaises an `ArithmeticError` exception if one of the arguments is not an\ninteger, or when the `divisor` is `0`.\n\n`Integer.floor_div/2` performs *floored* integer division. This means that\nthe result is always rounded towards negative infinity.\n\nIf you want to perform truncated integer division (rounding towards zero),\nuse `Kernel.div/2` instead.","ref":"Integer.Extension.html#floor_div/2"},{"type":"function","title":"Examples - Integer.Extension.floor_div/2","doc":"iex> Integer.floor_div(5, 2)\n    2\n    iex> Integer.floor_div(6, -4)\n    -2\n    iex> Integer.floor_div(-99, 2)\n    -50","ref":"Integer.Extension.html#floor_div/2-examples"},{"type":"task","title":"mix espec","doc":"Runs the specs.\n\nThis task starts the current application, loads up\n`spec/spec_helper.exs` and then requires all files matching the\n`spec/**/_spec.exs` pattern in parallel.\n\nA list of files can be given after the task name in order to select\nthe files to compile:\n\n    mix espec spec/some/particular/file_spec.exs\n\nIn case a single file is being tested, it is possible pass a specific\nline number:\n\n    mix espec spec/some/particular/file_spec.exs:42","ref":"Mix.Tasks.Espec.html"},{"type":"task","title":"Command line options - mix espec","doc":"* `--focus`      - run examples with `focus` only\n  * `--silent`     - no output\n  * `--order`      - run examples in the order in which they are declared\n  * `--sync`       - run all specs synchronously ignoring 'async' tag\n  * `--trace`      - detailed output\n  * `--cover`      - enable code coverage\n  * `--only`       - run only tests that match the filter `--only some:tag`\n  * `--exclude`    - exclude tests that match the filter `--exclude some:tag`\n  * `--string`     - run only examples whose full nested descriptions contain string `--string 'only this'`\n  * `--seed`       - seeds the random number generator used to randomize tests order\n  * `--stale`      - The --stale command line option attempts to run only those test files which reference modules that have changed since the last time you ran this task with --stale","ref":"Mix.Tasks.Espec.html#module-command-line-options"},{"type":"task","title":"Configuration - mix espec","doc":"* `:spec_paths` - list of paths containing spec files, defaults to `[\"spec\"]`.\n    It is expected all spec paths to contain a `spec_helper.exs` file.\n\n  * `:spec_pattern` - a pattern to load spec files, defaults to `*_spec.exs`.\n\n  * `:test_coverage` - a set of options to be passed down to the coverage mechanism.","ref":"Mix.Tasks.Espec.html#module-configuration"},{"type":"task","title":"Coverage - mix espec","doc":"The `:test_coverage` configuration accepts the following options:\n\n  * `:output` - the output for cover results, defaults to `\"cover\"`\n  * `:tool`   - the coverage tool\n\nBy default, a very simple wrapper around OTP's `cover` is used as a tool,\nbut it can be overridden as follows:\n\n    test_coverage: [tool: CoverModule]\n\n`CoverModule` can be any module that exports `start/2`, receiving the\ncompilation path and the `test_coverage` options as arguments. It must\nreturn an anonymous function of zero arity that will be run after the\ntest suite is done or `nil`.","ref":"Mix.Tasks.Espec.html#module-coverage"},{"type":"function","title":"Mix.Tasks.Espec.parse_file/1","doc":"","ref":"Mix.Tasks.Espec.html#parse_file/1"},{"type":"function","title":"Mix.Tasks.Espec.parse_files/1","doc":"","ref":"Mix.Tasks.Espec.html#parse_files/1"},{"type":"function","title":"Mix.Tasks.Espec.run/1","doc":"Callback implementation for  Mix.Task.run/1 .","ref":"Mix.Tasks.Espec.html#run/1"},{"type":"task","title":"mix espec.init","doc":"Creates necessary files.\n\nThis tasks creates `spec/spec_helper.exs`","ref":"Mix.Tasks.Espec.Init.html"},{"type":"function","title":"Mix.Tasks.Espec.Init.run/1","doc":"Callback implementation for  Mix.Task.run/1 .","ref":"Mix.Tasks.Espec.Init.html#run/1"},{"type":"module","title":"Mix.Utils.Stale","doc":"","ref":"Mix.Utils.Stale.html"},{"type":"function","title":"Mix.Utils.Stale.agent_manifest_name/0","doc":"","ref":"Mix.Utils.Stale.html#agent_manifest_name/0"},{"type":"function","title":"Mix.Utils.Stale.agent_write_manifest/0","doc":"","ref":"Mix.Utils.Stale.html#agent_write_manifest/0"},{"type":"function","title":"Mix.Utils.Stale.manifest/0","doc":"","ref":"Mix.Utils.Stale.html#manifest/0"},{"type":"function","title":"Mix.Utils.Stale.set_up_stale_sources/1","doc":"","ref":"Mix.Utils.Stale.html#set_up_stale_sources/1"},{"type":"function","title":"Mix.Utils.Stale.write_manifest/1","doc":"","ref":"Mix.Utils.Stale.html#write_manifest/1"},{"type":"exception","title":"ESpec.AssertReceive.AssertReceiveError","doc":"","ref":"ESpec.AssertReceive.AssertReceiveError.html"},{"type":"exception","title":"ESpec.AssertionError","doc":"Defines ESpec.AssertionError exception.\nThe exception is raised by `ESpec.Assertions.Interface.raise_error/4` when example fails.","ref":"ESpec.AssertionError.html"},{"type":"exception","title":"ESpec.DocExample.Error","doc":"","ref":"ESpec.DocExample.Error.html"},{"type":"exception","title":"ESpec.ExampleRunner.AfterExampleError","doc":"","ref":"ESpec.ExampleRunner.AfterExampleError.html"},{"type":"exception","title":"ESpec.LetError","doc":"","ref":"ESpec.LetError.html"},{"type":"exception","title":"ESpec.RefuteReceive.RefuteReceiveError","doc":"","ref":"ESpec.RefuteReceive.RefuteReceiveError.html"}],"proglang":"elixir","content_type":"text/markdown","producer":{"name":"ex_doc","version":"0.38.2"}}